class TIMER1
{
   public:
     TIMER1()
     {
        //Timer1, Mode 14 WGM13..0 1110
        //Vorteilung 1, CS12..0  001 
        TCCR1B = (1<<WGM13) | (1<<WGM12) | (0<<CS12) | (0<<CS11) | (1<<CS10) ;
        TCCR1A = (1<<COM1A1) | (0<<COM1A0) | (1<<COM1B1) | (0<<COM1B0) | (1<<WGM11) | (0<<WGM10);

        //Arduino Micro:
        //TOP=ICR1=3199
        //N=1
        //fpwm = fclock / ( N*(1+TOP) ) = 16000000/3200==5000Hz    

        //ATmega32 (HIER):
        //fpwm = fclock / ( N*(1+TOP) ) = 8000000/800==10000Hz    

    
        ICR1 = MOTORMAX;

        DDRD |= (1<<PD5) | (1<<PD4); //auf Ausgang setzen.            
        DDRC |= 0b00001100;  //Richtung

        //Alle Motoren aus:
        PORTC &= ~(1<<PC2);
        OCR1B = 0;
        PORTC &= ~(1<<PC3);
        OCR1A = 0;

    
        //ISR aufgrund Überlauf Timer 1:
        TIMSK |= (1<<OCIE1A);    //ATmega32
    
        //Interrupts aktivieren
        sei();            
     }

        //Ansteuerung der Motoren
        void fahrt(int links, int rechts)  //Wertebereich: +-799
        {
            if(links>MOTORMAX)
                links = MOTORMAX;
            if(links<-MOTORMAX)
                links = -MOTORMAX;
            if(rechts>MOTORMAX)
                rechts = MOTORMAX;
            if(rechts<-MOTORMAX)
                rechts = -MOTORMAX;

            if(links==0)    
            {
                PORTC &= ~(1<<PC2);
                OCR1B = 0;
            }
            else if(links<0)
            {
                PORTC |=  (1<<PC2);
                OCR1B = -links;
            }
            else
            {
                PORTC &= ~(1<<PC2);
                OCR1B = links;
            }

            if(rechts==0)    
            {
                PORTC &= ~(1<<PC3);
                OCR1A = 0;
            }
            else if(rechts<0)
            {
                PORTC |=  (1<<PC3);
                OCR1A = -rechts;
            }
            else
            {
                PORTC &= ~(1<<PC3);
                OCR1A = rechts;
            }
        }
     
} timer1;
